Account - Basics
==============

* [Zur Startseite der Hilfe](help)


**Registrierung**

Nicht alle Friendica-Knoten bieten die Möglichkeit zur Registrierung. 
Wenn die Registrierung möglich ist, wird ein "Registrieren"-Link unter dem Login-Feld auf der Startseite angezeigt, der zur Registrierungsseite führt. 
Die Stärke unseres Netzwerks ist, dass die verschiedenen Knoten komplett kompatibel zueinander sind. 
Wenn der Knoten, den Du besuchst, keine Registrierung anbietet, oder wenn Du glaubst, dass Dir eine andere Seite möglicherweise besser gefällt, dann kannst Du hier eine <a href="http://dir.friendica.com/siteinfo">Liste von öffentlichen Servern (Knoten)</a> finden und den Knoten heraus suchen, der am Besten zu Deinen Anforderungen passt. 

Wenn Du Deinen eigenen Server aufsetzen willst, kannst Du das ebenfalls machen. 
Besuche <a href="http://friendica.com/download">die Friendica-Webseite</a>, um den Code mit den Installationsanleitungen herunterzuladen. 
Es ist ein einfacher Installationsprozess, den jeder mit ein wenig Erfahrungen im Webseiten-Hosting oder mit grundlegenden Linux-Erfahrungen einfach handhaben kann.


*OpenID*

Das erste Feld auf der Registrierungsseite ist für eine OpenID-Adresse. 
Wenn Du keine OpenID-Adresse hast oder nicht wünschst, diese zu nutzen, dann lasse das Feld frei. 
Wenn Du einen OpenID-Account hast und diesen nutzen willst, gib die Adresse in das Feld ein und klicke auf "Registrieren". 
Friendica wird versuchen, so viele Informationen wie möglich von Deinem OpenID-Provider zu übernehmen, um diese in Dein Profil auf dieser Seite einzutragen. 


*Dein vollständiger Name*

Bitte trage Deinen vollständigen Namen **so ein, wie Du ihn im System anzeigen lassen willst**. 
Viele Leute nutzen ihren richtigen Namen hierfür, allerdings besteht für dich keine Pflicht, das auch so zu machen.


*Email-Adresse*

Bitte trage eine richtige Email-Adresse ein. 
Deine Email-Adresse wird **niemals** veröffentlicht. 
Wir benötigen diese, um Dir Account-Informationen und die Login-Daten zu schicken. 
Du erhältst zudem von Zeit zu Zeit Benachrichtigungen über eingegangene Nachrichten oder Punkte, die Deine Aufmerksamkeit benötigen. 
Du hast aber auch die Möglichkeit, diese Nachrichten in Deinen Account-Einstellungen komplett abzuschalten. 

Du musst nicht Deine Haupt-Email-Adresse sein, jedoch wird eine funktionierende Adresse benötigt. 
Ohne dieses kannst Du weder Dein Initialpasswort erhalten, noch Dein Passwort zurücksetzen. 
Dies ist die einzige persönliche Information, die korrekt sein muss.
 

*Spitzname/Nickname*

Der Spitzname wird benötigt, um eine Webadresse für viele Deiner persönlichen Seiten zu erstellen. 
Auch wird dieser wie eine Email-Adresse genutzt, wenn eine Verbindung zu anderen Personen hergestellt werden soll. 
Durch die Art, wie der Spitzname genutzt wird, gibt es bestimmte Einschränkungen. Er darf nur US-ASCII-Textzeichen und Nummern enthalten und er muss zudem mit einem Buchstaben beginnen. 
Er muss außerdem einzigartig im System sein. 
Dieser Spitzname wird an vielen Stellen genutzt, um Deinen Account zu identifizieren, und kann daher später nicht mehr geändert werden.


*Verzeichnis-Eintrag*

Das Registrierungsformular erlaubt es dir, direkt auszuwählen, ob Du im Onlineverzeichnis aufgelistet wirst oder nicht. 
Das ist wie ein Telefonbuch und Du kannst entscheiden, nicht aufgeführt zu werden. 
Wir bitten dich, "Ja" zu wählen, so dass dich andere Leute (Freunde, Familie etc.) finden können. 
Wenn Du "Nein" wählst, wirst Du hauptsächlich unsichtbar sein und nur wenige Möglichkeiten zur Interaktion haben. 
Was auch immer Du wählst, kann jederzeit nach dem Login in Deinen Account-Einstellungen geändert werden.


*Registrierung*

Sobald Du die nötigen Informationen eingegeben hast, klicke auf "Registrieren". 
Eine Email mit den Registrierungsdetails und Deinem Initialpasswort wird an die hinterlegte Email-Adresse geschickt. 
Bitte prüfe den Posteingang (inkl. dem Spam-Ordner).


**Login-Seite**

Gib auf der "Login"-Seite die Informationen ein, die Du mit der oben genannten Email erhalten hast. 
Du kannst entweder Deinen Spitznamen oder die Email-Adresse als Login-Namen nutzen.

Wenn Du Deinen Account nutzt, um unterschiedliche '[Seiten](help/Pages)' zu verwalten, die die gleiche Email-Adresse verwenden, dann nutze bitte den Spitznamen des Accounts, der verwaltet werden soll.

*Wenn* Dein Account OpenID nutzt, dann kannst Du Deine OpenID-Adresse als Login-Name nutzen und das Passwort-Feld frei lassen. 
Du wirst zu Deinem OpenID-Anbieter weitergeleitet, wo Du Deine Anmeldung abschließt. 

Wenn Du OpenID nicht nutzt, dann gib Dein Passwort ein, das Du mit der Registrierungsmail erhalten hast. 
Das Passwort muss genau so geschrieben werden, wie es in der Email steht; Groß- und Kleinschreibung wird beachtet. 
Falls Du Schwierigkeiten beim Login hast, prüfe bitte, ob z. B. Deine Feststelltaste aktiv ist.


**Passwort ändern**

Besuche nach Deinem ersten Login bitte die Einstellungsseite und wechsle das Passwort in eines, dass Du Dir merken kannst. 


**Der Anfang**

Ein ['Tipp für neue Mitglieder'](newmember)-Link zeigt sich in den ersten beiden Wochen auf Deiner Startseite, um Dir erste Informationen zum Start zu bieten.


**Persönliche Daten exportieren**

Du kannst eine Kopie Deiner persönlichen Daten in einer XML-Datei exportieren. 
Gehe hierzu in Deinen Einstellungen auf "Persönliche Daten exportieren".


**Schau Dir ebenfalls folgende Seiten an**

* [Profile](help/Profiles)

* [Gruppen und Privatssphäre](help/Groups-and-Privacy)

* [Account löschen](help/Remove-Account)

